/*
 * Proyecto: TestMariaDB
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 17/09/2018
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   COMPONENT oMariaDBDataSource1
   COMPONENT oLabel1
   COMPONENT oEdPings
   COMPONENT oTimer1

   METHOD CreateForm()
   METHOD Timer1Timer( oSender )
   METHOD MariaDBDataSource1Create( oSender )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

CLASS TMariaDBDataSource FROM XMariaDBDataSource

   DATA oTimer
   DATA nPings INIT 0

   METHOD Connect( cConnect )
   METHOD Disconnect()
   METHOD Destroy( lFree )

END CLASS

//--------------------------------------------------------------------------

METHOD Connect( cConnect ) CLASS TMariaDBDataSource

   LOCAL lOk

   lOk := ::Super:Connect( cConnect )

   IF lOk
      IF ::oTimer == NIL
         ::oTimer := TTimer():Create()
      ENDIF
      ::oTimer:nInterval := 1000
      ::oTimer:OnTimer := {|| MYSQL_PING( ::Handle ), ::nPings ++ }
      ::oTimer:lEnabled := .T.
   ENDIF

RETURN lOk

//--------------------------------------------------------------------------

METHOD DisConnect() CLASS TMariaDBDataSource

   IF ::oTimer != NIL
      ::oTimer:lEnabled := .F.
   ENDIF

RETURN ::Super:DisConnect()

//--------------------------------------------------------------------------

METHOD Destroy( lFree ) CLASS TMariaDBDataSource

   IF ::oTimer != NIL
      ::oTimer:End()
      ::oTimer := NIL
   ENDIF

RETURN ::Super:Destroy( lFree )

//------------------------------------------------------------------------------

METHOD Timer1Timer( oSender ) CLASS TForm1
   ::oEdPings:Value := ::oMariaDBDataSource1:nPings
RETURN Nil

//------------------------------------------------------------------------------

METHOD MariaDBDataSource1Create( oSender ) CLASS TForm1
   oSender:lConnected := .T.
RETURN Nil

//------------------------------------------------------------------------------
